/*
 *  UltimateIRCd - an Internet Relay Chat Daemon, src/s_ultimate.c
 *
 *  Copyright (C) 2002 by the past and present ircd coders, and others.
 *  Refer to the documentation within doc/authors/ for full credits and copyrights.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: s_ultimate.c,v 1.10 2002/03/09 23:28:18 shadowmaster Exp $
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <sys/un.h>
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <sys/stat.h>
#include <fcntl.h>
#include <utmp.h>
#include "h.h"


#define AllocCpy(x,y) x = (char *) MyMalloc(strlen(y) + 1); strcpy(x,y)

aCRline *crlines = NULL;

char *cannotjoin_msg = NULL;


/*
**
** m_settings November 18th 1999 - ShadowMaster
**   Will display the dynconf settings for local or remote server.
**   /SETTINGS <parm> <optional servername>
**
*/


extern int report_dynconf (aClient *);
extern int report_network (aClient *);
extern int report_options (aClient *);
extern int report_hostmasks (aClient *);
extern int report_services (aClient *);
void cr_report (aClient *);

int
m_settings (aClient * cptr, aClient * sptr, int parc, char *parv[])
{

  if (MyClient (sptr) && !IsAnOper (sptr))
    {
      if (parc < 2)
	{

	  sendto_one (sptr,
		      ":%s %d %s :\2~~~~~~~~ UltimateIRCd Settings ~~~~~~~~\2",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);


	  sendto_one (sptr, ":%s %d %s :Use \2/SETTINGS (COMMAND)",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);


	  sendto_one (sptr,
		      ":%s %d %s :\2CHANNELS\2         View Allowed Channel Settings",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2~~~~~~~~~~~~~~~~~~~~~~~~~~\2",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, rpl_str (RPL_ENDOFSETTINGS), me.name, sptr->name);


	  return 0;
	}
      if (mycmp (parv[1], "channels") == 0)
	{
	  cr_report (sptr);
	  return 0;
	}

      else
	{
	  sendto_one (sptr,
		      ":%s %d %s :Error: %s is not a supported parameter for SETTINGS.",
		      me.name, RPL_SETTINGS, sptr->name, parv[1]);
	  sendto_one (sptr, rpl_str (RPL_ENDOFSETTINGS), me.name, sptr->name);
	  return 0;
	}

    }
  if (hunt_server (cptr, sptr, ":%s SETTINGS %s :%s", 2, parc, parv) ==
      HUNTED_ISME)
    {
      if (parc < 2)
	{

	  sendto_one (sptr,
		      ":%s %d %s :\2~~~~~~~~ UltimateIRCd Settings ~~~~~~~~\2",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :Use \2/SETTINGS (COMMAND) [Server]",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2DYNCONF\2          View IRCd Settings",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2NETINFO\2          View Network Info",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2OPTIONS\2          View Network Options",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2SERVICES\2         View Network Services Settings",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2HOSTMASKS\2        View Network Hostmask Settings",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2CHANNELS\2         View Allowed Channel Settings",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr,
		      ":%s %d %s :\2~~~~~~~~~~~~~~~~~~~~~~~~~~\2",
		      me.name, RPL_SETTINGS, sptr->name);

	  sendto_one (sptr, rpl_str (RPL_ENDOFSETTINGS), me.name, sptr->name);


	  return 0;
	}

      if (mycmp (parv[1], "dynconf") == 0)
	{
	  (void) report_dynconf (sptr);
	  return 0;
	}
      else if (mycmp (parv[1], "netinfo") == 0)
	{
	  (void) report_network (sptr);
	  return 0;
	}
      else if (mycmp (parv[1], "options") == 0)
	{
	  (void) report_options (sptr);
	  return 0;
	}
      else if (mycmp (parv[1], "hostmasks") == 0)
	{
	  (void) report_hostmasks (sptr);
	  return 0;
	}

      else if (mycmp (parv[1], "services") == 0)
	{
	  (void) report_services (sptr);
	  return 0;
	}

      else if (mycmp (parv[1], "channels") == 0)
	{
	  cr_report (sptr);
	  return 0;
	}

      else
	{
	  sendto_one (sptr,
		      ":%s %d %s :Error: %s is not a supported parameter for SETTINGS.",
		      me.name, RPL_SETTINGS, sptr->name, parv[1]);
	  sendto_one (sptr, rpl_str (RPL_ENDOFSETTINGS), me.name, sptr->name);
	  return 0;
	}

    }
  return 0;
}

/*
** m_sethost
**
** Based on m_sethost by Stskeeps
*/
int
m_sethost (aClient * cptr, aClient * sptr, int parc, char *parv[])
{
  aClient *acptr;
  char *p;
  int bad_dns, dots;

  if (check_registered (sptr))
    return 0;

  /*
   *  Getting rid of the goto's - ShadowMaster
   */
  if (!IsPrivileged (sptr))
    {
      sendto_one (sptr, err_str (ERR_NOPRIVILEGES), me.name, parv[0]);
      return 0;
    }


  if (parc < 3 && IsPerson (sptr))
    {
      if (MyConnect (sptr))
	{
	  sendto_one (sptr,
		      ":%s NOTICE %s :*** [SETHOST] -- Syntax: /SETHOST <nickname> <hostname>",
		      me.name, parv[0]);
	}
      return 0;
    }

  /* Safety net. */
  if (parc < 3)
    {
      return 0;
    }

  /* paranoia */
  if (parv[2] == NULL)
    {
      return 0;
    }

  if (strlen (parv[2]) > HOSTLEN)
    {
      if (MyConnect (sptr))
	{
	  sendto_one (sptr,
		      ":%s NOTICE %s :*** [SETHOST] -- Error: Hostnames are limited to %d characters.",
		      me.name, sptr->name, HOSTLEN);
	}
      return 0;
    }
  /*
   * We would want this to be at least 4 characters long.  - ShadowMaster
   */
  if (strlen (parv[2]) < 4)
    {
      if (MyConnect (sptr))
	{
	  sendto_one (sptr,
		      ":%s NOTICE %s :*** [SETHOST] -- Error: Please enter a valid hostname.",
		      me.name, sptr->name);
	}
      return 0;
    }

  dots = 0;
  p = parv[2];
  bad_dns = NO;
  while (*p)
    {
      if (!isalnum (*p))
	{
	  if ((*p != '-') && (*p != '.'))
	    bad_dns = YES;
	}
      if (*p == '.')
	dots++;

      p++;
    }

  if (bad_dns == YES)
    {
      if (MyConnect (sptr))
	{
	  sendto_one (sptr,
		      ":%s NOTICE %s :*** [SETHOST] -- Error: A hostname may contain a-z, A-Z, 0-9, '-' & '.'",
		      me.name, parv[0]);
	}
      return 0;
    }
  if (!dots)
    {
      if (MyConnect (sptr))
	{
	  sendto_one (sptr,
		      ":%s NOTICE %s :*** [SETHOST] -- Error: You must have at least one . (dot) in the hostname.",
		      me.name, parv[0]);
	}
      return 0;
    }


  if ((acptr = find_person (parv[1], NULL)))
    {
      if (!IsHidden (acptr) && MyClient (acptr))
	{
	  SetHidden (acptr);
	}
      /*
       * Now using strncpyzt instead of ircsprintf - ShadowMaster
       */
      strncpyzt (acptr->user->virthost, parv[2], HOSTLEN);

      sendto_serv_butone (cptr, ":%s SETHOST %s %s", me.name, acptr->name,
			  parv[2]);

      if (MyClient (sptr))
	{
	  if (sptr == acptr)
	    {
	      sendto_netinfo
		("from %s: \2[SETHOST]\2 -- %s (%s@%s) set their virtualhost to \2%s\2",
		 me.name, parv[0], sptr->user->username, sptr->user->host,
		 sptr->user->virthost);
	      sendto_one (sptr,
			  ":%s NOTICE %s :*** [SETHOST] -- Your virtual hostname is now \2%s\2",
			  me.name, parv[0], sptr->user->virthost);
	    }

	  else
	    {
	      sendto_netinfo
		("from %s: \2[SETHOST]\2 -- %s set the virtualhost of %s (%s@%s) to \2%s\2",
		 me.name, parv[0], acptr->name, acptr->user->username,
		 acptr->user->host, acptr->user->virthost);
	      sendto_one (sptr,
			  ":%s NOTICE %s :*** [SETHOST] -- Set the virtualhost of %s to \2%s\2",
			  me.name, parv[0], acptr->name,
			  acptr->user->virthost);

	    }


	}
    }
  else
    {
      sendto_one (sptr, err_str (ERR_NOSUCHNICK), me.name, sptr->name,
		  parv[1]);
      return 0;
    }
  return 0;
}


/*
** m_vhost
**
** Based on the original m_oper in bahamut.
** Allows regular users to use VHOST's setup for them by
** the server admin. - ShadowMaster
**
** parv[0] = sender prefix
** parv[1] = username
** parv[2] = password
*/
int
m_vhost (aClient * cptr, aClient * sptr, int parc, char *parv[])
{
  aConfItem *aconf;
  char *name, *password, *encr;

#define CRYPT_VHOST_PASSWORD
#ifdef CRYPT_VHOST_PASSWORD
  extern char *crypt ();

#endif

  name = parc > 1 ? parv[1] : (char *) NULL;
  password = parc > 2 ? parv[2] : (char *) NULL;

  if (!IsServer (cptr) && (BadPtr (name) || BadPtr (password)))
    {
      sendto_one (sptr, err_str (ERR_NEEDMOREPARAMS),
		  me.name, parv[0], "VHOST");
      return 0;
    }
  if (!(aconf = find_conf_name (name, CONF_VHOST)))
    {
      sendto_one (sptr,
		  ":%s NOTICE %s :*** [VHOST] -- There is no V Line for your host",
		  me.name, parv[0]);

      sendto_netinfo
	("from %s: \2[VHOST]\2 -- Failed VHOST attempt by %s (%s@%s)",
	 me.name, parv[0], sptr->user->username, sptr->user->host);
      return 0;
    }

#ifdef CRYPT_VHOST_PASSWORD
  /* use first two chars of the password they send in as salt */
  /* passwd may be NULL pointer. Head it off at the pass... */
  if (password && *aconf->passwd)
    encr = crypt (password, aconf->passwd);
  else
    encr = "";
#else
  encr = password;
#endif /* CRYPT_VHOST_PASSWORD */

  if ((aconf->status & CONF_VHOST) &&
      StrEq (encr, aconf->passwd) && !attach_conf (sptr, aconf))
    {
      int old = (sptr->umode & ALL_UMODES);

      /*
       * In theory we can have very long hostnames. But we wanna stay securely on the safe side of
       * things. Prevent admins from goofing up and reject the /VHOST if its too long then warn the user
       * and the opers about it - ShadowMaster
       */

      if (strlen (aconf->host) > HOSTLEN)
	{
	  sendto_netinfo
	    ("from %s: \2[VHOST]\2 -- %s (%s@%s) attempted to set a vhost with login \2%s\2. The host set in the vhost.conf for this users is longer than %d chars long and was rejected.",
	     me.name, parv[0], sptr->user->username, sptr->user->host, name,
	     HOSTLEN);
	  sendto_one (sptr,
		      ":%s NOTICE %s :*** [VHOST] -- The hostname set in the vhost.conf for your login is too long. Please contact the admin to have this corrected.",
		      me.name, parv[0]);
	  return 0;
	}

      if (!IsHidden (sptr))
	{
	  SetHidden (sptr);
	}

      strcpy (sptr->user->virthost, aconf->host);
      sendto_serv_butone (cptr, ":%s SETHOST %s %s", me.name, parv[0],
			  sptr->user->virthost);

      sendto_netinfo
	("from %s: \2[VHOST]\2 -- %s (%s@%s) set their virtualhost to \2%s\2 using userid \2%s\2",
	 me.name, parv[0], sptr->user->username, sptr->user->host,
	 sptr->user->virthost, name);
      sendto_one (sptr,
		  ":%s NOTICE %s :*** [VHOST] -- Your virtual hostname is now \2%s\2",
		  me.name, parv[0], sptr->user->virthost);

      send_umode_out (cptr, sptr, old);




    }
  else
    {
      (void) detach_conf (sptr, aconf);
      sendto_one (sptr, err_str (ERR_PASSWDMISMATCH), me.name, parv[0]);
      sendto_netinfo
	("from %s: \2[VHOST]\2 -- Failed VHOST attempt by %s (%s@%s)",
	 me.name, parv[0], sptr->user->username, sptr->sockhost);

    }
  return 0;
}


/*
** m_ircops
**
** Based on m_ircops by ScOrP|On
** Rewritten by ShadowMaster for UltimateIRCd
**
** Lists online IRC Operators showing their oper level,
** home server and away status. - ShadowMaster
**
*/
int
m_ircops (aClient * cptr, aClient * sptr, int parc, char *parv[])
{
  aClient *acptr;
  char buf[BUFSIZE];
  char buf2[BUFSIZE];
  int locals = 0, globals = 0;

  if (!MyClient (sptr))
    return 0;

  strcpy (buf,
	  "\2~~~~~~~~~~\2 Online IRC Operators \2~~~~~~~~~~\2");
  sendto_one (sptr, rpl_str (RPL_IRCOPS), me.name, parv[0], buf);

  sendto_one (sptr, rpl_str (RPL_IRCOPS), me.name, parv[0], "-");

  for (acptr = client; acptr; acptr = acptr->next)
    {
      if (!IsULine (acptr) && IsAnOper (acptr) && IsHelpOp (acptr))
	{
	  if (!acptr->user)
	    continue;

	  if (acptr->user->away)
	    continue;

	  if (IsNetAdmin (acptr))
	    strcpy (buf2, "Net Admin");
	  else if (IsNetCoAdmin (acptr))
	    strcpy (buf2, "Net Co Admin");
	  else if (IsServerAdmin (acptr))
	    strcpy (buf2, "Server Admin");
	  else if (IsServerCoAdmin (acptr))
	    strcpy (buf2, "Server Co Admin");
	  else if (IsGuestAdmin (acptr))
	    strcpy (buf2, "Guest Admin");
	  else if (IsOper (acptr))
	    strcpy (buf2, "Global Oper");
	  else if (IsLocOp (acptr))
	    strcpy (buf2, "Local Oper");

	  ircsprintf (buf, "\2%-20s\2 -- %s (%s)", acptr->name, buf2,
		      acptr->user->server);
	  sendto_one (sptr, rpl_str (RPL_IRCOPS), me.name, parv[0], buf);

	  sendto_one (sptr, rpl_str (RPL_IRCOPS), me.name, parv[0], "-");

	  if (IsOper (acptr))
	    globals++;
	  else
	    locals++;
	}
    }


  ircsprintf (buf,
	      "Total: \2%d\2 IRCOp%s availible - \2%d\2 Globa%s, \2%d\2 Loca%s",
	      globals + locals, (globals + locals) > 1 ? "s" : "", globals,
	      globals > 1 ? "ls" : "l", locals, locals > 1 ? "ls" : "l");
  sendto_one (sptr, rpl_str (RPL_IRCOPS), me.name, parv[0], buf);


  strcpy (buf,
	  "\2~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\2");
  sendto_one (sptr, rpl_str (RPL_IRCOPS), me.name, parv[0], buf);

  sendto_one (sptr, rpl_str (RPL_ENDOFIRCOPS), me.name, parv[0]);
  return 0;
}

/*
**
** check_clones by Crash
**
**	Slight modifications for UltimateIRCd by ShadowMaster.
**
**	Checks the ENTIRE network for clients with the same host,
**	counts them and returns 0 if the clone count is below MAXCLONES
**	and -1 if the clone count is above MAXCLONES.
**	Ignores ULined clients.
**
*/
int
check_clones (aClient * cptr, aClient * sptr)
{
  aClient *acptr;
  int c = 1;

  for (acptr = client; acptr; acptr = acptr->next)
    {
      /* first, are they a "Real" person? */
      if (!acptr->user)
	continue;

      /* lets let services clone ;-) */
      if (IsULine (acptr))
	continue;

      /* just ignore servers */
      if (IsServer (acptr))
	continue;

      /* dont count the client doing it */
      if (!strcasecmp (sptr->name, acptr->name))
	continue;

      /* If the network wants its opers to be allowed to clone.... - ShadowMaster */
      if ((OPER_CLONE_LIMIT_BYPASS == 1) && IsAnOper (acptr))
	continue;

      /* ahh! the hosts match!  count it */
      if (!strcasecmp (sptr->user->host, acptr->user->host))
	c++;
    }

  /* WHAT?! exceding clone limit!? KILL EM?! */

  if ((CLONE_LIMIT - c) < 0)
    {
      return -1;
    }
  return 0;
}


/* Star Channel Restric */


/*
** channel_canjoin from UnrealIRCd
*/
int
channel_canjoin (aClient * sptr, char *name)
{
  aCRline *p;

  if (IsAnOper (sptr))
    return 1;
  if (IsULine (sptr))
    return 1;
  if (!crlines)
    return 1;
  for (p = crlines; p; p = p->next)
    {
      if (!match (p->channel, name))
	return 1;
    }
  return 0;
}

/*
** cr_add from UnrealIRCd
*/
int
cr_add (char *channel, int type)
{
  aCRline *fl;

  fl = (aCRline *) MyMalloc (sizeof (aCRline));

  AllocCpy (fl->channel, channel);
  fl->type = type;
  fl->next = crlines;
  fl->prev = NULL;
  if (crlines)
    crlines->prev = fl;
  crlines = fl;
  return 0;
}

aCRline *
cr_del (fl)
     aCRline *fl;
{
  aCRline *p, *q;
  for (p = crlines; p; p = p->next)
    {
      if (p == fl)
	{
	  q = p->next;
	  MyFree ((char *) p->channel);
	  /* chain1 to chain3 */
	  if (p->prev)
	    {
	      p->prev->next = p->next;
	    }
	  else
	    {
	      crlines = p->next;
	    }
	  if (p->next)
	    {
	      p->next->prev = p->prev;
	    }
	  MyFree ((aCRline *) p);
	  return q;
	}
    }
  return NULL;
}


/*
** cr_loadconf from UnrealIRCd
*/
int
cr_loadconf (char *filename, int type)
{
  char buf[2048];
  char *x, *y;
  FILE *f;

  f = fopen (filename, "r");
  if (!f)
    return -1;

  while (fgets (buf, 2048, f))
    {
      if (buf[0] == '#' || buf[0] == '/' || buf[0] == '\0' || buf[0] == '\n'
	  || buf[0] == '\r')
	continue;
      iCstrip (buf);
      x = strtok (buf, " ");
      if (mycmp (x, "allow") == 0)
	{
	  y = strtok (NULL, " ");
	  if (!y)
	    continue;
	  cr_add (y, 0);
	}
      else if (mycmp (x, "msg") == 0)
	{
	  y = strtok (NULL, "");
	  if (!y)
	    continue;
	  if (cannotjoin_msg)
	    MyFree ((char *) cannotjoin_msg);
	  cannotjoin_msg = MyMalloc (strlen (y) + 1);
	  strcpy (cannotjoin_msg, y);
	}
    }
  return 0;
}

/*
** cr_rehash
*/
void
cr_rehash (void)
{
  aCRline *p, q;

  for (p = crlines; p; p = p->next)
    {
      if ((p->type == 0) || (p->type == 2))
	{
	  q.next = cr_del (p);
	  p = &q;
	}
    }
  cr_loadconf (IRCD_RESTRICT, 1);
}

/*
** cr_report from UnrealIRCd
**
** Adapted for UltimateIRCd by ShadowMaster
*/
void
cr_report (aClient * sptr)
{
  aCRline *tmp;
  char *filemask;

  if (!crlines)
    {
      sendto_one (sptr,
		  ":%s %d %s :There are currently no channel restrictions in place on %s",
		  me.name, RPL_SETTINGS, sptr->name, me.name);
      sendto_one (sptr, rpl_str (RPL_ENDOFSETTINGS), me.name, sptr->name);
      return;
    }

  sendto_one (sptr,
	      ":%s %d %s :\2~~~~~~~~ Allowed Channels ~~~~~~~~\2",
	      me.name, RPL_SETTINGS, sptr->name);

  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);


  for (tmp = crlines; tmp; tmp = tmp->next)
    {
      filemask = BadPtr (tmp->channel) ? "<NULL>" : tmp->channel;

      sendto_one (sptr, ":%s %d %s :%s",
		  me.name, RPL_SETTINGS, sptr->name, filemask);

    }
  sendto_one (sptr, ":%s %d %s :", me.name, RPL_SETTINGS, sptr->name);

  sendto_one (sptr,
	      ":%s %d %s :\2~~~~~~~~~~~~~~~~~~~~~~~~~~\2",
	      me.name, RPL_SETTINGS, sptr->name);

  sendto_one (sptr, rpl_str (RPL_ENDOFSETTINGS), me.name, sptr->name);

}

/* End Channel Restrict */


/*
** m_makepass based on the code by Nelson Minar (minar@reed.edu)
**
** Copyright (C) 1991, all rights reserved.
**
**	parv[0] = sender prefix
**	parv[1] = password to encrypt
*/
int
m_makepass (cptr, sptr, parc, parv)
     aClient *cptr, *sptr;
     int parc;
     char *parv[];
{
  static char saltChars[] =
    "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
  char salt[3];
  extern char *crypt ();
  int useable = 0;

  if (parc > 1)
    {
      if (strlen (parv[1]) >= 1)
	useable = 1;
    }

  if (useable == 0)
    {
      sendto_one (sptr,
		  ":%s NOTICE %s :*** Encryption's MUST be atleast 1 character in length",
		  me.name, parv[0]);
      return 0;
    }
  srandom (time (0));
  salt[0] = saltChars[random () % 64];
  salt[1] = saltChars[random () % 64];
  salt[2] = 0;

  if ((strchr (saltChars, salt[0]) == NULL)
      || (strchr (saltChars, salt[1]) == NULL))
    {
      sendto_one (sptr, ":%s NOTICE %s :*** Illegal salt %s", me.name,
		  parv[0], salt);
      return 0;
    }


  sendto_one (sptr, ":%s NOTICE %s :*** Encryption for [%s] is %s", me.name,
	      parv[0], parv[1], crypt (parv[1], salt));
  return 0;
}
